DECLARE FUNCTION sureQuit% ()
DECLARE SUB instructions ()
DECLARE SUB aboutNE ()
DECLARE SUB redrawFace ()
DECLARE SUB timingControl (speed%)
DECLARE SUB initGfx ()
DECLARE SUB postGame ()
DECLARE FUNCTION menu% ()
DECLARE SUB preTitle ()
DECLARE SUB areaExit (direction$)
DECLARE SUB debugInfo ()
DECLARE SUB tips (areaNum%)
DECLARE SUB move (direction$)
DECLARE SUB console ()
DECLARE SUB drawArea (areaNum%)
DECLARE SUB init ()


'    Wry 3 version 3: Malodorous & Stale
'       By: Erik Eriksen

DEFINT A-Z                'defines unspecified variables as "int"s.

'variable constants
CONST TRUE = 1
CONST FALSE = 0
CONST titleHeight = 15
CONST titleWidth = 20
CONST mrFaceHeight = 8
CONST mrFaceWidth = 7
CONST groundHeight = 8
CONST groundWidth = 20

'sprite arrays.
DIM SHARED MRFACE(mrFaceHeight, mrFaceWidth) 'sprites are actually a global
DIM SHARED GROUND(groundHeight)              '2d or 1d array of colors pixels.
DIM SHARED WATER(5)

'variable declarations
DIM SHARED areaNum AS INTEGER
DIM SHARED pX AS INTEGER
DIM SHARED pY AS INTEGER
DIM SHARED game AS INTEGER
DIM SHARED mainLoop AS INTEGER
DIM SHARED redraw AS INTEGER
DIM SHARED speed AS INTEGER
DIM SHARED inJump AS INTEGER
DIM SHARED jumpMaxHeight AS INTEGER
DIM SHARED goingUp AS INTEGER

speed = 1    'default debug.

mainLoop = TRUE

CALL initGfx            'game graphics initialization sub.
CALL preTitle           'nukem enterprises logo

DO WHILE mainLoop = TRUE

  playGame% = menu%            'main menu

  IF playGame% = FALSE THEN    'if quit selected
    CALL postGame              'display post game info
    mainLoop = FALSE           'set main program loop to stop
    game = FALSE               'set actual game loop to stop

  ELSEIF playGame% = TRUE THEN 'if play game was selected
    game = TRUE                'set game loop to run
    SCREEN 13
    CALL init                  'initialize in game variables.

  END IF                       'end of menu function return if-block

  'the actual game
  DO WHILE game = TRUE         'the in-game will loop to here
 
    IF redraw = TRUE THEN      'if something called for a redraw...
      CALL drawArea(areaNum)   'DO IT!
    END IF

    in$ = INKEY$               'scan for user input

    CALL debugInfo             'display debug information

    'movement to the left.
    IF in$ = CHR$(0) + CHR$(75) THEN
      CALL move("l")

    'movement to the right
    ELSEIF in$ = CHR$(0) + CHR$(77) THEN
      CALL move("r")

    'jump movement (set it so that you're jumping)
    ELSEIF in$ = " " THEN
      CALL move("u")

    'F1 help/tip press
    ELSEIF in$ = CHR$(0) + CHR$(59) THEN
      CALL tips(areaNum)

    'open game console. (to debug stuff)
    ELSEIF in$ = "~" THEN
      CALL console
 
    'quit handling
    ELSEIF in$ = "q" OR in$ = CHR$(27) THEN
      game = sureQuit% 'returns false or true
      
    END IF

    IF pX > 300 THEN     'if it's time to move to next screen
      CALL areaExit("r")

    ELSEIF pX < 10 AND areaNum <> 1 THEN 'if it's time to move to previous screen
      CALL areaExit("l")
    END IF

    'Jump movement.
    IF inJump = TRUE AND goingUp = TRUE THEN
      PUT (pX, pY), MRFACE
      pY = pY - 1
      PUT (pX, pY), MRFACE, XOR
      IF pY <= 150 THEN
        goingUp = FALSE
      END IF


    ELSEIF inJump = TRUE AND goingUp = FALSE THEN
      PUT (pX, pY), MRFACE
      pY = pY + 1
      PUT (pX, pY), MRFACE, XOR
      IF pY >= 180 THEN
        pY = 180
        inJump = FALSE
      END IF
    END IF
   
    CALL timingControl(speed)       'regulates game time.

  LOOP 'end of game loop

LOOP   'end of program loop

END


'Sprite data follows below:
'--------------------------

MRFACE:
'Mr. Face Data
DATA 00, 00, 00, 00, 00, 00, 00
DATA 00, 06, 06, 06, 06, 06, 00
DATA 00, 06, 06, 06, 06, 06, 00
DATA 00, 06, 00, 06, 00, 06, 00
DATA 00, 06, 00, 06, 00, 06, 00
DATA 00, 06, 06, 06, 06, 06, 00
DATA 00, 06, 00, 00, 00, 06, 00
DATA 00, 06, 06, 06, 06, 06, 00

GROUND:
'ground texture data
DATA 02
DATA 02
DATA 02
DATA 06
DATA 06
DATA 06
DATA 06
DATA 06

WATER:
'water texture data
DATA 00
DATA 09
DATA 09
DATA 01
DATA 01
DATA 01

SUB aboutNE
CLS

FOR starGenerator = 1 TO 1000
  XCoordinate = CINT(RND * 800)
  YCoordinate = CINT(RND * 500)
  PSET (XCoordinate, YCoordinate), 7
NEXT starGenerator

COLOR 10
LOCATE 1, 20
PRINT "About Nukem Enterprises"
LOCATE 2, 19
PRINT ""

COLOR 7
LOCATE 3
PRINT "           Nukem Enterprises (NE for short) is a company alias that I"
PRINT "create programs under. I program in both Basic and C++. I started this"
PRINT "programming alias way back in 1999. Back then it was called Eriksen Inc."
PRINT "This soon changed to Sublime Inc. for a short period of time before "
PRINT "finally ending at it's current name."
PRINT "          As of the make of this game I think I can say I have an ok"
PRINT "grasp on programming concepts and such. (Even though this source is "
PRINT "a little jumbled, that's b/c I didn't plan anything out, I just wrote)"
PRINT "I'm mostly programming in C++ now for the Linux platform. Qbasic has "
PRINT "sort of taken the ~side road~ for me. "
PRINT "         I've created many programs over the years and they can all be"
PRINT "found at my website. If the site is down or no longer exists you can"
PRINT "always ICQ me or e-mail me and I'll direct you to the location of the"
PRINT "current address of the website. (I think it's changed a good 4 times"
PRINT "in the past 7 years)."
PRINT "                                                    -Erik Eriksen"
PRINT " Web site: http://eriks.servehttp.com"
PRINT "           http://www.geocities.com/nukemn0w/"
PRINT "      ICQ: 17951293"
PRINT "   E-mail: shamrice@optonline.net"
COLOR 4
PRINT "                                      Press any key to go back"



DO: LOOP WHILE INKEY$ = ""

END SUB

SUB areaExit (direction$)

SELECT CASE direction$

  CASE "l"         'exit to the left of the screen
    areaNum = areaNum - 1
    pX = 299
    redraw = TRUE

  CASE "r"         'exit to the right of the screen
    areaNum = areaNum + 1
    pX = 10
    redraw = TRUE

END SELECT

END SUB

SUB console

'debug console sub
'-------------------
'debug console allows you to manipulate many aspects of the game
'by changed the value of the the variables during play time.
   
    LOCATE 3, 1: COLOR 7
    INPUT " > ", debug$

    SELECT CASE debug$
      CASE "c"                      'change game attribute mode
        LOCATE 3, 1
        INPUT "?> ", change$        'what val to change
        IF change$ = "x" THEN       'change player X value
          LOCATE 3, 1
          INPUT "pX to> ", pX

        ELSEIF change$ = "y" THEN   'change player Y value
          LOCATE 3, 1
          INPUT "pY to> ", pY

        ELSEIF change$ = "a" THEN   'change area number
          LOCATE 3, 1
          INPUT "areaNum to> ", areaNum
        END IF

      CASE "r"          'force redraw screen
        redraw = TRUE

      CASE "q"          'forced quit game
        CLS
        PRINT "Forced quit called!"
        END

    END SELECT

    'clean up.
    LOCATE 3, 1: COLOR 7
    PRINT "                                      "
   

END SUB

SUB debugInfo

  'debug: display x & y coords
  LOCATE 1, 1: COLOR 15
  PRINT "X: "; pX
  LOCATE 2, 1: COLOR 15
  PRINT "Y: "; pY


END SUB

SUB drawArea (areaNum)

'the actual game.
CLS

'draw level.

SELECT CASE areaNum

  CASE 1
    'draw the ground
   
    FOR i% = 0 TO 310
      PUT (i%, 187), GROUND
    NEXT i%

    'draw the water
    FOR i% = 0 TO 50
      PUT ((i% + 80), 187), WATER, PSET
    NEXT i%

    'draw the sun
    CIRCLE (220, 30), 10, 14
    PAINT (220, 30), 14

    'place mr face
    PUT (pX, pY), MRFACE

  CASE 2
    'draw the ground
  
    FOR i% = 0 TO 310
      PUT (i%, 187), GROUND
    NEXT i%

    'draw the sun
    CIRCLE (220, 30), 10, 14
    PAINT (220, 30), 14

    'place mr face
    PUT (pX, pY), MRFACE


END SELECT

redraw = FALSE      'no need to redraw, it was just done

END SUB

SUB init

'variable initialization
pX = 15
pY = 180
game = TRUE
areaNum = 1
redraw = TRUE
inJump = FALSE
jumpMaxHeight = 100

END SUB

SUB initGfx
'initializes graphics and related variables.

SCREEN 13

'get sprites (aka initialize arrays)
LOCATE 15, 30: COLOR 15
PRINT "Loading and initializing sprites..."

FOR y% = 1 TO mrFaceHeight
  FOR x% = 1 TO mrFaceWidth
    READ MRFACE
    PSET (x%, y%), MRFACE
  NEXT x%
NEXT y%

GET (1, 1)-(mrFaceWidth, mrFaceHeight), MRFACE

FOR y% = 1 TO groundHeight
  READ GROUND
  PSET (1, y%), GROUND
NEXT y%

GET (1, 1)-(1, groundHeight), GROUND

FOR y% = 1 TO 5
  READ WATER
  PSET (1, y%), WATER
NEXT y%

GET (1, 1)-(1, 5), WATER

END SUB

SUB instructions
CLS

FOR starGenerator = 1 TO 1000
  XCoordinate = CINT(RND * 800)
  YCoordinate = CINT(RND * 500)
  PSET (XCoordinate, YCoordinate), 7
NEXT starGenerator

COLOR 10
PRINT
PRINT "                               Instructions on how to play"
PRINT "                              ============================="
COLOR 7
PRINT
PRINT " In this game, the objective is to progress to the end. Wow, that's a really bad"
PRINT " definiton of the game... so...general. Well, in more detail, you fight your way"
PRINT " from level to level using your trusty 9mm and killing bad guys.You have to jump"
PRINT " over obsticles and other stuff. Not that hard of a concept to understand."
PRINT
COLOR 15
PRINT "  Controls:"
PRINT " -----------"
COLOR 7
PRINT " Space bar -  Jump (and it's actually DECENT!)"
PRINT " Right Arrow - Move right"
PRINT " Left Arrow - Move left (lost yet?)"
PRINT " Up Arrow -  Jump"
PRINT
COLOR 15
PRINT "  Weapons and Fighting:"
PRINT " -----------------------"
COLOR 7
PRINT " 9mm - This is your primary weapon. It can shoot an enemy from roughly 8 tiles"
PRINT "       away. It takes ~5 shots to down a simple enemy. A white arrow above the"
PRINT "       enemies head will appear when you are within shooting range."
PRINT ""
PRINT " Enemy's Attack - Yes, thats right! The enemies can fire back at you. If you are"
PRINT "                  ~7 tiles away they can shoot you. After they see you they will"
PRINT "                  continue shooting and running after you until you until one of"
PRINT "                  3 things happens: you get out of range, they die, you die."
COLOR 4
PRINT "Press any key for next page..."
DO: LOOP WHILE INKEY$ = ""

CLS
FOR starGenerator = 1 TO 1000
  XCoordinate = CINT(RND * 800)
  YCoordinate = CINT(RND * 500)
  PSET (XCoordinate, YCoordinate), 7
NEXT starGenerator

COLOR 10
PRINT "                               History of the Wry Series:"
PRINT "                              ============================"
COLOR 7
PRINT " The Wry series started with one of my first full length programs I worked on in"
PRINT " Qbasic. It started before this ~company~ came into existince way back in about"
PRINT " December or november of 1998. (company was formed in Feb/Jan. 1999). It was a"
PRINT " text based comedy game started by me and my friend. (who goes under the allias"
PRINT " of sk8er). Almost single handedly inspired by A Beefinian Tale. "
PRINT ""
PRINT " The original name of the game was ~Lost~, and it was a good name that went"
PRINT " along with the ramshackle story of the first episode. (final ver. episode 3)."
PRINT " Well, episodes one and two where completed.. or almost completed when we got "
PRINT " tired of the constant programming and stopped for a long time. In this time gap"
PRINT " a bunch of progammers known as ~Groovy Concepts~ released their game called"
PRINT " ~Lost~. (now a legendary RPG) One day a guy from ~Groovy Concepts~ told me that"
PRINT " I had to change the name of the game... ~BAH!~ I thought, but did it anyway."
PRINT
PRINT " That week in english class we had the vocab word ~Wry~. It meant a dry sense of"
PRINT " humor. I thought it fit perfect, so off I went, changed the title screen and"
PRINT " game name and started to program again. This time desiding to add 2 more "
PRINT " episodes. (one hidden). I sorta sluggishly finished the project due to my bad"
PRINT " programming skills, but it was released. Bug filled, typo infested, and just"
PRINT " plain corny. "
PRINT
PRINT " Most of the responses I recieved from it where good. Seeing that it was my"
PRINT " first full length project finished. (I'm known for starting many projects and"
PRINT " never finishing them). With this great response, one year later I desided to"
PRINT " make a sequel..."
COLOR 4
PRINT " Press any key for next page..."
DO: LOOP WHILE INKEY$ = ""

CLS
FOR starGenerator = 1 TO 1000
  XCoordinate = CINT(RND * 800)
  YCoordinate = CINT(RND * 500)
  PSET (XCoordinate, YCoordinate), 7
NEXT starGenerator

COLOR 10
PRINT "                               History of the Wry Series:"
PRINT "                              ============================"
COLOR 7
PRINT " I looked up in the thesaurus what was another word that meant ~Wry~, the"
PRINT " closest word I came up with was ~Grimace~. Desiding that it was a good name"
PRINT " I desided to start programming again. This time I was going for a side view"
PRINT " action game that had more gameplay than the original. When I started I had no"
PRINT " idea of how in the hell I was going to do this. Programming a moving player"
PRINT " jumping, shooting, and then also enemies and pits. I started thinking this"
PRINT " would be impossible."
PRINT
PRINT " So I asked on my message board how I should go about making the character"
PRINT " move. JMB responded and told me a basic theory of how to do it. I tryed it"
PRINT " and with a little tinkering it worked. (BTW, the method he suggested back"
PRINT " then, I no longer use... too complicated) I set up everything, took me quite"
PRINT " a while to finish, but I did. The response was less than Wry, but better than"
PRINT " a lot of my other programs. "
PRINT
PRINT " One year later I decided to create the sequel (now 2 years after the"
PRINT " original). I got demo length through it, maybe 5 levels. It looked better"
PRINT " than Grimace, but the playing just wasn't as good. I released the demo and it"
PRINT " faired ok I believe, but I didn't like programming for it nor the current"
PRINT " layout. So it was put in ~The forever delayed~ folder. Not touched since now"
PRINT " about another year later. I scrapped the whole thing and started anew. "
PRINT ""
PRINT " I guess that's all there is to the history of Wry."
COLOR 8
PRINT "     (For all those who didn't notice I liked the instructions from"
PRINT "     Wry 3 version .0.2.5 (Second Demo) and just chucked them in here. LAZY!)"

COLOR 4
PRINT " Press anykey to return to the menu."
DO: LOOP WHILE INKEY$ = ""

END SUB

FUNCTION menu%

' main menu function. returns a zero if they decide to quit
' and not play the game. otherwise the game will proceed to
' the first level.
returnVal% = 1
choice% = 1
chosen = FALSE
cursorY = 17
cursorYmask = 16
inMenu = TRUE

SCREEN 12
WHILE inMenu = TRUE
CLS

'the classic Wry "stars"
FOR starGenerator = 1 TO 1000
  XCoordinate = CINT(RND * 800)
  YCoordinate = CINT(RND * 500)
  PSET (XCoordinate, YCoordinate), 7
NEXT starGenerator

'Ok so I went a pretty much "straight line" code form of the
'title screen similar to that you would see in the old "Terror" source
'code. It seemed the best way to go though. The bitmap was WAYYYY too
'large and the draw command wasn't flexible enough (only 45degree angles).

'W
LINE (40, 15)-(105, 150), 6
LINE (105, 150)-(135, 100), 6
LINE (135, 100)-(165, 150), 6
LINE (165, 150)-(230, 15), 6
LINE (230, 15)-(190, 15), 6
LINE (190, 15)-(165, 70), 6
LINE (165, 70)-(135, 50), 6
LINE (135, 50)-(105, 70), 6
LINE (105, 70)-(80, 15), 6
LINE (80, 15)-(40, 15), 6
PAINT (45, 20), 6

'R
LINE (220, 150)-(240, 80), 6, BF
LINE (240, 90)-(260, 80), 6
LINE (260, 90)-(240, 100), 6
LINE (260, 80)-(280, 80), 6
LINE (260, 90)-(280, 90), 6
LINE (280, 80)-(300, 90), 6
LINE (280, 90)-(290, 95), 6
LINE (290, 95)-(300, 90), 6
PAINT (241, 95), 6

'Y
LINE (310, 80)-(340, 135), 6
LINE (340, 135)-(360, 115), 6
LINE (360, 115)-(330, 80), 6
LINE (330, 80)-(310, 80), 6
PAINT (315, 85), 6
LINE (280, 200)-(390, 80), 6
LINE (390, 80)-(410, 80), 6
LINE (410, 80)-(300, 200), 6
LINE (300, 200)-(280, 200), 6
PAINT (299, 199), 6

'3 (check out that one massive draw command string)
PSET (440, 15), 7
DRAW "r120 f20 d50 g20 f20 d50 g20 l120 u30 r80 e20 u20 h20 e20 u20 h20 l80 u30"
PAINT (445, 20), 7

COLOR 8
LOCATE 25, 25
PRINT "(c) 2006 Nukem Enterprises"

COLOR 7
LOCATE 16, 45
PRINT "ver. 0.3.01 build Feb 2006"

COLOR 7
LOCATE 17, 12
PRINT "Play game"
LOCATE 18, 12
PRINT "Instructions"
LOCATE 19, 12
PRINT "About NE"
LOCATE 20, 12
PRINT "Quit"

DO
 
  a$ = INKEY$
  COLOR 15
  LOCATE cursorY, 9
  PRINT "-"

  COLOR 0
  LOCATE cursorYmask, 9
  PRINT "  "

  IF a$ = CHR$(0) + CHR$(80) THEN
    IF cursorY + 1 <= 20 THEN
      cursorYmask = cursorY
      cursorY = cursorY + 1
      choice% = choice% + 1
    END IF

  ELSEIF a$ = CHR$(0) + CHR$(72) THEN
    IF cursorY - 1 >= 17 THEN
      cursorYmask = cursorY
      cursorY = cursorY - 1
      choice% = choice% - 1
    END IF

  ELSEIF a$ = (CHR$(13)) AND (cursorY = 17 OR cursorY = 20) THEN
    chosen = TRUE
    inMenu = FALSE

  ELSEIF a$ = CHR$(13) THEN
    SELECT CASE cursorY
      CASE 18: 'instructions
        chosen = TRUE
        

      CASE 19: 'about NE
        chosen = TRUE
        
    END SELECT

  END IF


LOOP WHILE chosen = FALSE

SELECT CASE choice%

  CASE 1:
    returnVal% = 1

  CASE 2:
    CALL instructions
    chosen = FALSE

  CASE 3:
    CALL aboutNE
    chosen = FALSE

  CASE 4:
    returnVal% = 0

END SELECT
WEND
menu% = returnVal%

END FUNCTION

SUB move (direction$)

SELECT CASE direction$
 
  CASE "l"                 'move player left
    PUT (pX, pY), MRFACE
    pX = pX - 2
   
    IF pX <= 2 THEN   'make sure they don't fall off screen in area 1
      pX = pX + 2
    END IF

    PUT (pX, pY), MRFACE, XOR
 
  CASE "r"                 'move player right
    PUT (pX, pY), MRFACE
    pX = pX + 2
    PUT (pX, pY), MRFACE, XOR


  CASE "u"                 'make player jump
    IF inJump = FALSE THEN
      inJump = TRUE
      goingUp = TRUE
    END IF

END SELECT

END SUB

SUB postGame

CLS
COLOR 7
PRINT "             Wry 3 : Stale & Malodorous"
PRINT "                  By: Erik Eriksen"
PRINT "           "
PRINT
PRINT " Thank you for playing Wry 3! It's only taken over 4 years of production"
PRINT " to bring you this stellar piece of crap. I must say though it was a lot"
PRINT " of fun to program and it's a hell of a lot better than the last two "
PRINT " demos of this game. (If you played them, I'm sure you'd agree :P)"
PRINT
PRINT " I hope you enjoyed playing this game and it didn't give you any kind of"
PRINT " weird diseases or rashes. If you're thinking it might have, I'd suggest"
PRINT " taking a better look at that there keyboard before you point your fingers"
PRINT " at me!"
PRINT
PRINT "       ...see? Dirty just as I insinuated. "
PRINT
PRINT " Anyway, If you want to go to my website or contact me, here's all the "
PRINT " info right here:"
PRINT
PRINT " Website: http://eriks.servehttp.com"
PRINT "          http://www.geocities.com/nukemn0w"
PRINT "  E-mail: shamrice@optonline.net"
PRINT "     ICQ: 17951293"


END SUB

SUB preTitle

'Displays the NE logo... that's all.
CLS
SCREEN 12

FOR starGenerator = 1 TO 1000
  XCoordinate = CINT(RND * 800)
  YCoordinate = CINT(RND * 500)
  PSET (XCoordinate, YCoordinate), 7
NEXT starGenerator

LOCATE 3, 1: COLOR 6
PRINT "                   "
PRINT "                  "
PRINT "                 "
PRINT "             "
PRINT "                     "
PRINT "                    "
PRINT "                    "
PRINT "              "
PRINT "                           << E n t e r p r i s e s >>"
LOCATE 16, 30: COLOR 15
PRINT "-=:: PRESENTS ::=-"

LOCATE 20: COLOR 8
PRINT "  ...yes I'm aware this company ~splash~ screen is over 6 years old..."
SLEEP 3


END SUB

FUNCTION sureQuit%
'asks if they want to quit from ingame.
'returns a false if they do (think want to still play? FALSE!)
'or true if they don't want to quit.

chosen = FALSE

LOCATE 10, 10
COLOR 15
PRINT "Are you sure you want to quit? [y/n]"

WHILE chosen = FALSE

  a$ = INKEY$

  IF a$ = "y" OR a$ = "Y" THEN
    sureQuit% = FALSE
    chosen = TRUE
  
  ELSEIF a$ = "n" OR a$ = "N" THEN
    sureQuit = TRUE
    chosen = TRUE
    redraw = TRUE
  
  END IF

WEND


END FUNCTION

SUB timingControl (speed%)
'regulates the game speed. The speed parameter recieves and argument
'that determines how fast the game runs.
'
'  1 = Fast (slow computer)
'  2 = Medium (average computer)
'  3 = Slow (fast computer)
'
SELECT CASE speed

  CASE 1:   'fast game .: slow computer
    gameSpeed = 1.001

  CASE 2:   'medium game .: medium computer
    gameSpeed = 1.1

  CASE 3:   'slow game .: fast computer
    gameSpeed = 1.5

END SELECT

FOR i! = 1 TO gameSpeed     'the closer the numbers, the quicker the prog
  t! = TIMER               't represents the timer
  WHILE t! = TIMER         'while this is true
    WAIT &H3DA, 8         'waits for an 8 bit (1byte) reply from time
    WAIT &H3DA, 8, 8      'same but uses XOR to make sure
  WEND                    'wend=loop while true
NEXT i!                    'incriment the for loop

END SUB

SUB tips (areaNum)

LOCATE 8
PRINT "Tips for Area "; areaNum; ":"
PRINT ""

SELECT CASE areaNum

  CASE 1:
    LOCATE 10
    PRINT "Arrow keys move, space bar is jump"
    PRINT "This area is to get comfortable with"
    PRINT "the controls... Have fun! :)"

END SELECT

DO
LOOP WHILE INKEY$ = ""

redraw = TRUE

END SUB

